﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;
using System.Threading.Tasks;

namespace fgxavi.Common.Business.Repositories
{
    public interface IQueryableRepository<TEntity> where TEntity : class
    {
        Task<int> CountAsync { get; }
        Task<bool> ContainsAsync(TEntity item);
        Task<int> InsertAsync(TEntity item);
        Task<int> UpdateAsync(TEntity item);
        Task<int> DeleteAsync(TEntity item);
        IQueryable<TEntity> Find(string path = null);
        IQueryable<TEntity> Find(Func<TEntity, bool> predicate, string path = null);
        IQueryable<TEntity> Find(Expression<Func<TEntity, bool>> predicate, string path = null);
    }
}
