﻿using System.Data.Entity;

namespace fgxavi.Common.Business.Repositories
{
    public static class RepositoryExtensions
    {
        public static T Update<T>(this DbSet<T> dbSet, T obj, DbContext context)
            where T : class
        {
            // Recupera l'entitat original de la base de dades.
            //var original = dbSet.Find()
            // Obté l'entitat del context de la base de dades.
            var entity = dbSet.Attach(obj);
            // Recorre per propietats de l'entitat amb Reflexion.
            foreach (var p in typeof(T).GetProperties())
            {
                // Obté el valor de la propietat.
                var v = p.GetValue(obj, null);
                // Si el valor de la propietat és nul no la modifica a la base de dades.
                // if (v == null) continue;
                // Estableix la propietat de l'entitat com a modificada perquè s'envii a la base de dades.
                context.Entry(entity).Property(p.Name).IsModified = true;
            }
            // Retorna l'entitat.
            return obj;
        }
    }
}
