﻿using fgxavi.PagedQuery;
using Newtonsoft.Json;

namespace fgxavi.Common.Data.Translators
{
    public class JsonTranslator : ITranslator
    {
        public TResult Translate<T, TResult>(T source)
            where T : class
            where TResult : class
        {
            JsonSerializerSettings jss = new JsonSerializerSettings()
            {
                PreserveReferencesHandling = PreserveReferencesHandling.Objects,
                Converters = new JsonConverter[] { new PagedQueryConverter() }
            };
            string json = JsonConvert.SerializeObject(source, Formatting.Indented, jss);
            TResult target = JsonConvert.DeserializeObject<TResult>(json, jss);
            return target;
        }
    }
}
