﻿using System.Web.Http;
using System.Web.Http.OData.Query;

namespace fgxavi.Common.Services
{
    public sealed class ControlledQueryableAttribute : QueryableAttribute
    {
        public ControlledQueryableAttribute()
        {
            this.AllowedArithmeticOperators = AllowedArithmeticOperators.None;
            this.AllowedFunctions = AllowedFunctions.AllFunctions;
            this.AllowedLogicalOperators = AllowedLogicalOperators.All;
            this.AllowedQueryOptions =
                AllowedQueryOptions.Skip |
                AllowedQueryOptions.Top |
                AllowedQueryOptions.Filter |
                AllowedQueryOptions.OrderBy |
                AllowedQueryOptions.InlineCount |
                AllowedQueryOptions.Select |
                AllowedQueryOptions.Expand;
            this.MaxTop = 100;
        }
    }
}
