﻿using fgxavi.PagedQuery;
using System;
using System.Data.Entity;
using System.Linq.Expressions;
using System.ServiceModel;
using System.Threading.Tasks;

namespace fgxavi.Common.Services
{
    [ServiceContract]
    public interface IService<TEntity, TContract>
        where TEntity : class
        where TContract : class
    {
        [OperationContract]
        Task<int> CountAsync();
        //[OperationContract]
        //Task<int> CountByAsync(Func<TEntity, bool> predicate);
        //[OperationContract]
        //Task<int> CountByExpAsync(Expression<Func<TEntity, bool>> predicate);
        [OperationContract]
        Task<bool> ContainsAsync(TContract item);
        //[OperationContract]
        //Task<bool> ContainsByAsync(Func<TEntity, bool> predicate);
        //[OperationContract]
        //Task<bool> ContainsByExpAsync(Expression<Func<TEntity, bool>> predicate);
        [OperationContract]
        Task<int> InsertAsync(TContract item);
        [OperationContract]
        Task<int> UpdateAsync(TContract item);
        [OperationContract]
        Task<int> DeleteAsync(TContract item);
        [OperationContract]
        Task<PagedQuery<TContract>> FindAsync(string path = null, int pageNumber = 1, int pageSize = 10);
        //[OperationContract]
        //Task<PagedQuery<TContract>> FindByAsync(Func<TEntity, bool> predicate, string path = null, int pageNumber = 1, int pageSize = 10);
        //[OperationContract]
        //Task<PagedQuery<TContract>> FindByExpAsync(Expression<Func<TEntity, bool>> predicate, string path = null, int pageNumber = 1, int pageSize = 10);
    }
}
