
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, 2012 and Azure
-- --------------------------------------------------
-- Date Created: 11/20/2013 22:33:49
-- Generated from EDMX file: L:\Development\Gupcat\src\Implementation\Data Layer\fgxavi.Gupcat.Data.EntitiesLib\GupcatModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
--USE [gupcat];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_Desconegut_inherits_Identitat]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identitats_Desconegut] DROP CONSTRAINT [FK_Desconegut_inherits_Identitat];
GO
IF OBJECT_ID(N'[dbo].[FK_IdentitatTIP]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TIPs] DROP CONSTRAINT [FK_IdentitatTIP];
GO
IF OBJECT_ID(N'[dbo].[FK_IdentitatUsuari]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Usuaris] DROP CONSTRAINT [FK_IdentitatUsuari];
GO
IF OBJECT_ID(N'[dbo].[FK_PersonaFisica_inherits_Identitat]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identitats_PersonaFisica] DROP CONSTRAINT [FK_PersonaFisica_inherits_Identitat];
GO
IF OBJECT_ID(N'[dbo].[FK_PersonaJuridica_inherits_Identitat]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identitats_PersonaJuridica] DROP CONSTRAINT [FK_PersonaJuridica_inherits_Identitat];
GO
IF OBJECT_ID(N'[dbo].[FK_Updated_inherits_Auditoria]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Auditories_Updated] DROP CONSTRAINT [FK_Updated_inherits_Auditoria];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Identitats]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identitats];
GO
IF OBJECT_ID(N'[dbo].[Identitats_Desconegut]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identitats_Desconegut];
GO
IF OBJECT_ID(N'[dbo].[Identitats_PersonaFisica]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identitats_PersonaFisica];
GO
IF OBJECT_ID(N'[dbo].[Identitats_PersonaJuridica]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identitats_PersonaJuridica];
GO
IF OBJECT_ID(N'[dbo].[TIPs]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TIPs];
GO
IF OBJECT_ID(N'[dbo].[Usuaris]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Usuaris];
GO
IF OBJECT_ID(N'[dbo].[Auditories]', 'U') IS NOT NULL
    DROP TABLE dbo.[Auditories];
GO
IF OBJECT_ID(N'[dbo].[Auditories_Updated]', 'U') IS NOT NULL
    DROP TABLE dbo.[Auditories_Updated];
GO

-- --------------------------------------------------
-- Dropping existing escalar functions
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[fn_CodiAplicacio]', 'FN') IS NOT NULL
	DROP FUNCTION [dbo].[fn_CodiAplicacio]
GO
IF OBJECT_ID(N'[dbo].[fn_BinaryToIpAddress]', 'FN') IS NOT NULL
	DROP FUNCTION [dbo].[fn_BinaryToIpAddress]
GO
IF OBJECT_ID(N'[dbo].[fn_IpAddressToBinary]', 'FN') IS NOT NULL
	DROP FUNCTION [dbo].[fn_IpAddressToBinary]
GO

-- --------------------------------------------------
-- Dropping existing stored procedures
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[sp_Auditoria_CrearTriggers]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_CrearTriggers]
GO
IF OBJECT_ID(N'[dbo].[sp_Auditoria_InsertByContextInfo]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_InsertByContextInfo]
GO
IF OBJECT_ID(N'[dbo].[sp_Auditoria_ContextInfo_Serialize]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Serialize]
GO
IF OBJECT_ID(N'[dbo].[sp_Auditoria_ContextInfo_Deserialize]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Deserialize]
GO
IF OBJECT_ID(N'[dbo].[sp_Auditoria_ContextInfo_Pop]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Pop]
GO
IF OBJECT_ID(N'[dbo].[sp_Auditoria_ContextInfo_Push]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Push]
GO
IF OBJECT_ID(N'[dbo].[sp_ObtenirInfoError]', 'P') IS NOT NULL
	DROP PROCEDURE [dbo].[sp_ObtenirInfoError]
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Identitats'
CREATE TABLE [dbo].[Identitats] (
    [IdentitatId] int IDENTITY(1,1) NOT NULL,
    [Comentaris] nvarchar(max)  NULL,
    [AltaData] datetime DEFAULT (getdate()) NOT NULL,
    [AltaUsuari] nvarchar(max)  NOT NULL,
    [BaixaData] datetime NULL,
    [BaixaUsuari] nvarchar(max) NULL,
    [ModData] datetime DEFAULT (getdate()) NOT NULL,
    [ModUsuari] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'TIPs'
CREATE TABLE [dbo].[TIPs] (
    [TIPId] int IDENTITY(1,1) NOT NULL,
    [Nombre] nvarchar(max)  NOT NULL,
    [Tipus] int  NOT NULL,
    [AltaData] datetime DEFAULT (getdate()) NOT NULL,
    [AltaUsuari] nvarchar(max)  NOT NULL,
    [BaixaData] datetime NULL,
    [BaixaUsuari] nvarchar(max) NULL,
    [ModData] datetime DEFAULT (getdate()) NOT NULL,
    [ModUsuari] nvarchar(max)  NOT NULL,
    [Identitat_IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Usuaris'
CREATE TABLE [dbo].[Usuaris] (
    [UsuariId] int IDENTITY(1,1) NOT NULL,
    [CodiUsuari] nvarchar(max)  NOT NULL,
    [Comentaris] nvarchar(max)  NULL,
    [AltaData] datetime DEFAULT (getdate()) NOT NULL,
    [AltaUsuari] nvarchar(max)  NOT NULL,
    [BaixaData] datetime NULL,
    [BaixaUsuari] nvarchar(max) NULL,
    [ModData] datetime DEFAULT (getdate()) NOT NULL,
    [ModUsuari] nvarchar(max)  NOT NULL,
    [Identitat_IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Auditories'
CREATE TABLE [dbo].[Auditories] (
	[AuditoriaId] int IDENTITY(1,1) NOT NULL,
	[Tipus] char(1) NOT NULL,
	[Aplicacio] varchar(10) NOT NULL,
	[ProcId] binary(4) NULL,
	[ProcName] varchar(128) NULL,
	[Taula] varchar(128) NOT NULL,
	[PKCamps] varchar(max) NOT NULL,
	[PKValors] varchar(max) NOT NULL,
	[Camps] nvarchar(max) NOT NULL,
	[Valors] nvarchar(max) NOT NULL,
	[Moment] datetime DEFAULT (getdate()) NOT NULL,
	[Usuari] varchar(10) NULL,
	[Ip] binary(16) NULL,
	[IpAdress] varchar(39) NULL,
	[UsuariHost] varchar(20) NULL,
	[Hostname] varchar(63) NULL
);
GO

-- Creating table 'Identitats_PersonaFisica'
CREATE TABLE [dbo].[Identitats_PersonaFisica] (
    [Cognom1] nvarchar(max)  NOT NULL,
    [Cognom2] nvarchar(max)  NOT NULL,
    [Nom] nvarchar(max)  NOT NULL,
    [IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Identitats_PersonaJuridica'
CREATE TABLE [dbo].[Identitats_PersonaJuridica] (
    [Nom] nvarchar(max)  NOT NULL,
    [IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Identitats_Desconegut'
CREATE TABLE [dbo].[Identitats_Desconegut] (
    [Nom] nvarchar(max)  NOT NULL,
    [IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Auditories_Updated'
CREATE TABLE [dbo].[Auditories_Updated] (
    [ValorsAnt] nvarchar(max)  NOT NULL,
    [CampsMod] nvarchar(max)  NOT NULL,
    [ValorsMod] nvarchar(max)  NOT NULL,
    [ValorsAntMod] nvarchar(max)  NOT NULL,
    [AuditoriaId] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [IdentitatId] in table 'Identitats'
ALTER TABLE [dbo].[Identitats]
ADD CONSTRAINT [PK_Identitats]
    PRIMARY KEY CLUSTERED ([IdentitatId] ASC);
GO

-- Creating primary key on [TIPId] in table 'TIPs'
ALTER TABLE [dbo].[TIPs]
ADD CONSTRAINT [PK_TIPs]
    PRIMARY KEY CLUSTERED ([TIPId] ASC);
GO

-- Creating primary key on [UsuariId] in table 'Usuaris'
ALTER TABLE [dbo].[Usuaris]
ADD CONSTRAINT [PK_Usuaris]
    PRIMARY KEY CLUSTERED ([UsuariId] ASC);
GO

-- Creating primary key on [AuditoriaId] in table 'Auditories'
ALTER TABLE [dbo].[Auditories]
ADD CONSTRAINT [PK_Auditories]
    PRIMARY KEY CLUSTERED ([AuditoriaId] ASC);
GO

-- Creating primary key on [IdentitatId] in table 'Identitats_PersonaFisica'
ALTER TABLE [dbo].[Identitats_PersonaFisica]
ADD CONSTRAINT [PK_Identitats_PersonaFisica]
    PRIMARY KEY CLUSTERED ([IdentitatId] ASC);
GO

-- Creating primary key on [IdentitatId] in table 'Identitats_PersonaJuridica'
ALTER TABLE [dbo].[Identitats_PersonaJuridica]
ADD CONSTRAINT [PK_Identitats_PersonaJuridica]
    PRIMARY KEY CLUSTERED ([IdentitatId] ASC);
GO

-- Creating primary key on [IdentitatId] in table 'Identitats_Desconegut'
ALTER TABLE [dbo].[Identitats_Desconegut]
ADD CONSTRAINT [PK_Identitats_Desconegut]
    PRIMARY KEY CLUSTERED ([IdentitatId] ASC);
GO

-- Creating primary key on [AuditoriaId] in table 'Auditories_Updated'
ALTER TABLE [dbo].[Auditories_Updated]
ADD CONSTRAINT [PK_Auditories_Updated]
    PRIMARY KEY CLUSTERED ([AuditoriaId] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Identitat_IdentitatId] in table 'Usuaris'
ALTER TABLE [dbo].[Usuaris]
ADD CONSTRAINT [FK_IdentitatUsuari]
    FOREIGN KEY ([Identitat_IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_IdentitatUsuari'
CREATE INDEX [IX_FK_IdentitatUsuari]
ON [dbo].[Usuaris]
    ([Identitat_IdentitatId]);
GO

-- Creating foreign key on [Identitat_IdentitatId] in table 'TIPs'
ALTER TABLE [dbo].[TIPs]
ADD CONSTRAINT [FK_IdentitatTIP]
    FOREIGN KEY ([Identitat_IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_IdentitatTIP'
CREATE INDEX [IX_FK_IdentitatTIP]
ON [dbo].[TIPs]
    ([Identitat_IdentitatId]);
GO

-- Creating foreign key on [IdentitatId] in table 'Identitats_PersonaFisica'
ALTER TABLE [dbo].[Identitats_PersonaFisica]
ADD CONSTRAINT [FK_PersonaFisica_inherits_Identitat]
    FOREIGN KEY ([IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [IdentitatId] in table 'Identitats_PersonaJuridica'
ALTER TABLE [dbo].[Identitats_PersonaJuridica]
ADD CONSTRAINT [FK_PersonaJuridica_inherits_Identitat]
    FOREIGN KEY ([IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [IdentitatId] in table 'Identitats_Desconegut'
ALTER TABLE [dbo].[Identitats_Desconegut]
ADD CONSTRAINT [FK_Desconegut_inherits_Identitat]
    FOREIGN KEY ([IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [AuditoriaId] in table 'Auditories_Updated'
ALTER TABLE [dbo].[Auditories_Updated]
ADD CONSTRAINT [FK_Updated_inherits_Auditoria]
    FOREIGN KEY ([AuditoriaId])
    REFERENCES [dbo].[Auditories]
        ([AuditoriaId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Creating all escalar functions
-- --------------------------------------------------

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Retorna el codi de l'aplicació de la base de dades.
-- =============================================
CREATE FUNCTION [dbo].[fn_CodiAplicacio]()
RETURNS varchar(10)
AS
BEGIN
	RETURN 'GUPCAT'
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Retorna l'adreça IPv4 o IPv6 de la seva representació binària.
-- =============================================
CREATE FUNCTION [dbo].[fn_BinaryToIpAddress]
(
	@bytes binary(16)
)
RETURNS varchar(39)
AS
BEGIN

DECLARE
	@part VARBINARY(2),
	@colIndex TINYINT,
	@ip VARCHAR(39)

SET @ip = ''

IF SUBSTRING(@bytes, 1, 12) = 0x000000000000000000000000
BEGIN
	SET @colIndex = 13
	WHILE @colIndex <= 16
		SELECT
			@part = SUBSTRING(@bytes, @colIndex, 1),
			@ip = @ip + CAST(CAST(@part AS TINYINT) AS VARCHAR(3))
				+ CASE @colIndex WHEN 16 THEN '' ELSE '.' END,
			@colIndex = @colIndex + 1
	IF @ip = '0.0.0.1'
		SET @ip = '::1'                    
END
ELSE
BEGIN
	SET @colIndex = 1
	WHILE @colIndex <= 16
	BEGIN
		SET @part = SUBSTRING(@bytes, @colIndex, 2)
		SELECT
			@ip = @ip + CAST('' as xml).value('xs:hexBinary(sql:variable("@part") )', 'varchar(4)')
				+ CASE @colIndex WHEN 15 THEN '' ELSE ':' END,
			@colIndex = @colIndex + 2
	END
END

RETURN @ip   

END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Retorna les dades binàries que representen una adreça IPv4 o IPv6.
-- =============================================
CREATE FUNCTION [dbo].[fn_IpAddressToBinary]
(
	@ip varchar(39)
)
RETURNS binary(16)
AS
BEGIN

DECLARE
	@bytes BINARY(16), @vbytes VARBINARY(16), @vbzone VARBINARY(2),
	@colIndex TINYINT, @prevColIndex TINYINT, @parts TINYINT, @limit TINYINT,
	@delim CHAR(1), @token VARCHAR(4), @zone VARCHAR(4)

SELECT
	@delim = '.', @prevColIndex = 0, @limit = 4, @vbytes = 0x, @parts = 0,
	@colIndex = CHARINDEX(@delim, @ip)

IF @colIndex = 0
BEGIN
	SELECT
		@delim = ':'
		, @limit = 8
		, @colIndex = CHARINDEX(@delim, @ip)
	WHILE @colIndex > 0
		SELECT
			@parts = @parts + 1
			, @colIndex = CHARINDEX(@delim, @ip, @colIndex + 1)
	SET @colIndex = CHARINDEX(@delim, @ip)
	IF @colIndex = 0
		RETURN NULL                    
END

SET @ip = @ip + @delim

WHILE @colIndex > 0
BEGIN

SET @token = SUBSTRING(@ip, @prevColIndex + 1, @Colindex - @prevColIndex - 1)

IF @delim = ':'
BEGIN
	SET @zone = RIGHT('0000' + @token, 4)
	SELECT
		@vbzone = CAST('' AS XML).value('xs:hexBinary(sql:variable("@zone"))', 'varbinary(2)'),
		@vbytes = @vbytes + @vbzone
	IF @token = ''
		WHILE @parts + 1 < @limit
			SELECT
				@vbytes = @vbytes + @vbzone,
				@parts = @parts + 1
END
ELSE
BEGIN
	SET @zone = SUBSTRING('' + master.sys.fn_varbintohexstr(CAST(@token AS TINYINT)), 3, 2)
	SELECT
		@vbzone = CAST('' AS XML).value('xs:hexBinary(sql:variable("@zone"))', 'varbinary(1)'),
		@vbytes = @vbytes + @vbzone
END

SELECT
	@prevColIndex = @colIndex,
	@colIndex = CHARINDEX(@delim, @ip, @colIndex + 1) 

END            

SET @bytes =
	CASE @delim
		WHEN ':' THEN @vbytes
		ELSE 0x000000000000000000000000 + @vbytes
	END

RETURN @bytes

END
GO

-- --------------------------------------------------
-- Creating all stored procedures
-- --------------------------------------------------

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Obté informació de l'error produït.
-- =============================================
CREATE PROCEDURE [dbo].[sp_ObtenirInfoError]
AS
BEGIN
	SELECT
		ERROR_NUMBER() AS ErrorNumber,
		ERROR_SEVERITY() AS ErrorSeverity,
		ERROR_STATE() AS ErrorState,
		ERROR_LINE () AS ErrorLine,
		ERROR_PROCEDURE() AS ErrorProcedure,
		ERROR_MESSAGE() AS ErrorMessage;
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Emmagatzema les dades d'auditoria d'una operació en el context de la sessió de la connexió actual
--              serialitzant-les en informació binària per transmetre la informació als disparadors corresponents.
-- =============================================
CREATE PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Serialize]
	@ProcId binary(4),
	@Usuari varchar(10),
	@IP binary(16) = NULL,
	@UsuariHost varchar(20) = NULL,
	@Hostname varchar(63) = NULL
AS
BEGIN
	DECLARE @CInfo varbinary(128)
	SELECT @CInfo =
		CAST(@ProcId AS binary(4)) +
		CAST(@Usuari AS binary(10)) +
		CAST(@IP AS binary(16)) +
		CAST(@UsuariHost AS binary(20)) +
		CAST(@Hostname AS varbinary(63))
	SET CONTEXT_INFO @CInfo
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Retorna les dades d'auditoria d'una operació
--              deserialitzant la informació binària del context de la sessió de la connexió actual
-- =============================================
CREATE PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Deserialize]
	@ProcId binary(4) OUT,
	@Usuari varchar(10) OUT,
	@IP binary(16) OUT,
	@UsuariHost varchar(20) OUT,
	@Hostname varchar(63) OUT
AS
BEGIN
	-- Obté el context de la sessió de la connexió actual.
	DECLARE @CInfo varbinary(128)
	SELECT @CInfo = CONTEXT_INFO()
	-- Deserialitza la informació binària i l'emmagatzema a la corresponent variable.
	SELECT
		@ProcId = CAST(SUBSTRING(@CInfo, 1, 4) AS binary(4)),
		@Usuari = CAST(SUBSTRING(@CInfo, 5, 10) AS varchar(10)),
		@IP = CAST(SUBSTRING(@CInfo, 15, 16) AS binary(16)),
		@UsuariHost = CAST(SUBSTRING(@CInfo, 31, 20) AS varchar(20)),
		@Hostname = CAST(SUBSTRING(@CInfo, 51, 63) AS varchar(63))
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Retorna les dades d'auditoria d'una operació
--              buidant el context de la sessió de la connexió actual.
-- =============================================
CREATE PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Pop]
	@ParentProcId int,
	@ProcId binary(4) OUT,
	@ProcName varchar(128) OUT,
	@Usuari varchar(10) OUT,
	@IP binary(16) OUT,
	@IpAddress varchar(39) OUT,
	@UsuariHost varchar(20) OUT,
	@Hostname varchar(63) OUT
AS
BEGIN
	IF CONTEXT_INFO() IS NULL OR CONTEXT_INFO() = 0x
		SELECT
			@ProcId = @ParentProcId,
			@Usuari = CURRENT_USER,
			@IP = dbo.fn_IpAddressToBinary(client_net_address),
			@UsuariHost = nt_username,
			@Hostname = hostname
		FROM sys.sysprocesses AS s
			INNER JOIN sys.dm_exec_connections AS decc ON s.spid = decc.session_id
		WHERE spid = @@SPID
	ELSE
	BEGIN
		-- Obté el context de la sessió de la connexió actual.
		EXEC dbo.sp_Auditoria_ContextInfo_Deserialize
			@ProcId OUTPUT,
			@Usuari OUTPUT,
			@IP OUTPUT,
			@UsuariHost OUTPUT,
			@Hostname OUTPUT
		-- Buida el context de la sessió de la connexió actual.
		SET CONTEXT_INFO 0x
	END
	-- Tradueix els valors binaris codificats:
	SELECT
		@ProcName = OBJECT_NAME(@ProcId),
		@IpAddress = dbo.fn_BinaryToIpAddress(@IP)
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Emmagatzema les dades d'auditoria d'una operació en el context de la sessió de la connexió actual.
-- =============================================
CREATE PROCEDURE [dbo].[sp_Auditoria_ContextInfo_Push]
	@ProcId binary(4),
	@Usuari varchar(10),
	@IP varchar(39),
	@UsuariHost varchar(20),
	@Hostname varchar(63)
AS
BEGIN
	-- Serialitza i emmagatzema la informació binària per transmetre la informació als disparadors corresponents.
	DECLARE @IpAddress binary(16)
	SELECT @IpAddress = dbo.fn_IpAddressToBinary(@IP)
	EXEC dbo.sp_Auditoria_ContextInfo_Serialize @ProcId, @Usuari, @IpAddress, @UsuariHost, @Hostname
END
GO

-- =============================================
-- Author:		Xavi Font Garcia
-- Create date: 24/11/2013
-- Description:	Registra una auditoria segons el context de la sessió de la connexió actual.
-- =============================================
CREATE PROCEDURE [dbo].[sp_Auditoria_InsertByContextInfo]
	@ParentProcId int,
	@Tipus char(1),
	@Aplicacio varchar(10),
	@Taula varchar(128),
	@PKCamps varchar(max),
	@PKValors varchar(max),
	@Camps varchar(max),
	@ValAnts varchar(max),
	@Valors varchar(max),
	@CampsMod varchar(max),
	@ValAntsMod varchar(max),
	@ValorsMod varchar(max),
	@AuditoriaId int = NULL OUTPUT
AS
BEGIN
	-- Deshabilita el recompte de files afectades per les sentències.
	SET NOCOUNT ON;
	-- Reverteix tots els canvis en una transacció en cas d'error.
	SET XACT_ABORT ON
	-- Inicia un bloc amb captura d'errors.
	BEGIN TRY
		-- Inicia una transacció.
		BEGIN TRANSACTION Auditoria_Insert;

		-- Obté les dades d'auditoria del context de la sessió de la connexió actual
		-- i allibera el context de la sessió.
		DECLARE
			@ProcId binary(4),
			@ProcName varchar(128),
			@Usuari varchar(10),
			@IP binary(16),
			@IpAddress varchar(39),
			@UsuariHost varchar(20),
			@Hostname varchar(63)
		EXEC sp_Auditoria_ContextInfo_Pop
			@ParentProcId,
			@ProcId OUTPUT,
			@ProcName OUTPUT,
			@Usuari OUTPUT,
			@IP OUTPUT,
			@IpAddress OUTPUT,
			@UsuariHost OUTPUT,
			@Hostname OUTPUT

		-- Inserta les dades de l'auditoria.
		INSERT INTO Auditories
			([Tipus], [Aplicacio], [ProcId], [ProcName], [Taula],
			[PKCamps], [PKValors], [Camps], [Valors],
			[Usuari], [Ip], [IpAdress], [UsuariHost], [Hostname])
		VALUES
			(@Tipus, @Aplicacio, @ProcId, @ProcName, @Taula,
			@PKCamps, @PKValors, @Camps,
			CASE WHEN @Tipus='D' THEN @ValAnts ELSE @Valors END,
			@Usuari, @IP, @IpAddress, @UsuariHost, @Hostname)

		-- Obté la clau primària de la nova fila insertada.
		SET @AuditoriaId = SCOPE_IDENTITY();

		-- Si el tipus d'auditoria és una modificació s'afegeixen les dades a la taula annexada.
		IF @Tipus = 'U'
			INSERT INTO Auditories_Updated
				([ValorsAnt], [CampsMod], [ValorsMod], [ValorsAntMod], [AuditoriaId])
			VALUES
				(@ValAnts, @CampsMod, @ValorsMod, @ValAntsMod, @AuditoriaId)

		-- Finalitza correctament la transacció.
		COMMIT TRANSACTION Auditoria_Insert;
	END TRY
	-- Captura els errors produïts.
	-- Si s'ha produït un error recula la transacció i retorna l'error.
	BEGIN CATCH
	    -- Recupera l'error produït.
		EXEC sp_ObtenirInfoError
		-- Si la transacció ha realitzat operacions les recula.
		IF (XACT_STATE()) = -1
			ROLLBACK TRANSACTION Auditoria_Insert
	END CATCH
END
GO

-- Creating stored procedure 'sp_Auditoria_CrearTriggers'
CREATE PROCEDURE [dbo].[sp_Auditoria_CrearTriggers]
AS
BEGIN

-- Defineix el separador dels camps:
DECLARE @separador char(1)
SELECT @separador='#'

-- Declara les variables del script de la creació del trigger de cada taula:
DECLARE @sql varchar(max), @Taula sysname

-- Declara i obté el cursor amb totes les taules on s'afegiran els disparadors:
DECLARE table_cursor CURSOR FOR
SELECT TABLE_NAME
FROM INFORMATION_SCHEMA.Tables
WHERE TABLE_TYPE='BASE TABLE' AND TABLE_NAME!='sysdiagrams' AND NOT TABLE_NAME LIKE 'Auditories%'
ORDER BY TABLE_NAME

-- Obre el cursor de les taules i obté la primera taula:
OPEN table_cursor
FETCH NEXT FROM table_cursor 
INTO @Taula

	-- Itera les taules del cursor mentre n'hi hagi:
	WHILE @@FETCH_STATUS = 0
	BEGIN

		-- Elimina el trigger d'auditoria de la taula si ja existeix:
		EXEC('IF OBJECT_ID (''tr_' + @Taula + '_Auditoria'', ''TR'') IS NOT NULL DROP TRIGGER tr_' + @Taula + '_Auditoria')

-- Genera el text del script que crearà el trigger de la taula:
SELECT @sql=
'CREATE TRIGGER tr_' + @Taula + '_Auditoria on ' + @Taula + '
FOR INSERT, UPDATE, DELETE AS
DECLARE
@sql varchar(max),
@Tipus char(1),
@PKWhere varchar(max),
@SelPKCamps varchar(max),
@SelPKValors varchar(max),
@SelNCamps varchar(max),
@SelValAnts varchar(max),
@SelValors varchar(max),
@SelCampsMod varchar(max),
@SelValAntsMod varchar(max),
@SelValorsMod varchar(max),
@ResPKCamps varchar(max),
@ResPKValors varchar(max),
@ResNCamps varchar(max),
@ResValAnts varchar(max),
@ResValors varchar(max),
@ResCampsMod varchar(max),
@ResValAntsMod varchar(max),
@ResValorsMod varchar(max)

IF exists (SELECT * FROM inserted)
	IF exists (SELECT * FROM deleted)
		SELECT @Tipus=''U''
	ELSE
		SELECT @Tipus=''I''
ELSE
	SELECT @Tipus=''D''

SELECT * INTO #ins FROM inserted
SELECT * INTO #del FROM deleted

SELECT
	@PKWhere=coalesce(@PKWhere + '' and'', '' on'') + '' i.'' + c.COLUMN_NAME + ''=d.'' + c.COLUMN_NAME,
	@SelPKCamps=coalesce(@SelPKCamps + '' + ''''' + @separador + ''''' + '','''') + '''''''' + c.COLUMN_NAME + '''''''',
	@SelPKValors=coalesce(@SelPKValors + '' + ''''' + @separador + ''''' + '','''') + ''convert(varchar(1000), coalesce(i.'' + c.COLUMN_NAME + '',d.'' + c.COLUMN_NAME + ''))''
FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS pk,
	INFORMATION_SCHEMA.KEY_COLUMN_USAGE c
WHERE pk.TABLE_NAME=''' + @Taula + '''
	and pk.CONSTRAINT_TYPE=''PRIMARY KEY''
	and c.TABLE_NAME=pk.TABLE_NAME
	and c.CONSTRAINT_NAME=pk.CONSTRAINT_NAME
ORDER BY c.ORDINAL_POSITION ASC

SELECT
	@SelNCamps = coalesce(@SelNCamps + ''+''''' + @separador + '''''+'', '''') + '''''''' + c.COLUMN_NAME + '''''''',
	@SelValAnts = coalesce(@SelValAnts + ''+''''' + @separador + '''''+'', '''') + ''convert(varchar(max), coalesce(d.'' + c.COLUMN_NAME + '',''''''''))'',
	@SelValors = coalesce(@SelValors + ''+''''' + @separador + '''''+'', '''') + ''convert(varchar(max), coalesce(i.'' + c.COLUMN_NAME + '',''''''''))''
FROM
	(SELECT ORDINAL_POSITION, COLUMN_NAME
	FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME=''' + @Taula + '''
	GROUP BY ORDINAL_POSITION, COLUMN_NAME) c
ORDER BY c.ORDINAL_POSITION ASC

SELECT
	@SelCampsMod = coalesce(@SelCampsMod + ''+''''' + @separador + '''''+'', '''') + '''''''' + c.COLUMN_NAME + '''''''',
	@SelValAntsMod = coalesce(@SelValAntsMod + ''+''''' + @separador + '''''+'', '''') + ''convert(varchar(max), coalesce(d.'' + c.COLUMN_NAME + '',''''''''))'',
	@SelValorsMod = coalesce(@SelValorsMod + ''+''''' + @separador + '''''+'', '''') + ''convert(varchar(max), coalesce(i.'' + c.COLUMN_NAME + '',''''''''))''
FROM
	(SELECT ORDINAL_POSITION, COLUMN_NAME
	FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME=''' + @Taula + '''
		AND sys.fn_IsBitSetInBitmask(COLUMNS_UPDATED(),
		COLUMNPROPERTY(OBJECT_ID(''' + @Taula + '''), COLUMN_NAME, ''ColumnID'')) <> 0
	GROUP BY ORDINAL_POSITION, COLUMN_NAME) c
ORDER BY c.ORDINAL_POSITION ASC

SELECT @sql =
''SELECT '' +
@SelPKCamps + '' ResPKCamps,'' +
@SelPKValors + '' ResPKValors,'' +
@SelNCamps + '' ResNCamps,'' +
@SelValAnts + '' ResValAnts,'' +
@SelValors + '' ResValors, '' +
@SelCampsMod + '' ResCampsMod,'' +
@SelValAntsMod + '' ResValAntsMod,'' +
@SelValorsMod + '' ResValorsMod '' +
''FROM #ins i full outer join #del d '' + @PKWhere

DECLARE @tmp TABLE
(
ResPKCamps varchar(max),
ResPKValors varchar(max),
ResNCamps varchar(max),
ResValAnts varchar(max),
ResValors varchar(max),
ResCampsMod varchar(max),
ResValAntsMod varchar(max),
ResValorsMod varchar(max)
)

INSERT INTO @tmp
EXEC (@sql)

SELECT
@ResPKCamps = ResPKCamps,
@ResPKValors = ResPKValors,
@ResNCamps = ResNCamps,
@ResValAnts = ResValAnts,
@ResValors = ResValors,
@ResCampsMod = ResCampsMod,
@ResValAntsMod = ResValAntsMod,
@ResValorsMod = ResValorsMod
FROM @tmp

EXEC sp_Auditoria_InsertByContextInfo
	@@ProcId,
	@Tipus,
	''GUPCAT'',
	''' + @Taula + ''',
	@ResPKCamps,
	@ResPKValors,
	@ResNCamps,
	@ResValAnts,
	@ResValors,
	@ResCampsMod,
	@ResValAntsMod,
	@ResValorsMod
'

		-- Crea el trigger d'auditoria per a cada taula:
		EXEC(@sql)
		--SELECT len(@sql), @sql

	-- Itera a la taula següent del cursor:
    FETCH NEXT FROM table_cursor INTO @Taula
	END

-- Tanca i allibera el cursor de les taules:
CLOSE table_cursor
DEALLOCATE table_cursor

END
GO

EXEC [dbo].[sp_Auditoria_CrearTriggers]

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------
