
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, 2012 and Azure
-- --------------------------------------------------
-- Date Created: 01/13/2014 16:37:08
-- Generated from EDMX file: S:\Development\fgxavi.Gupcat\fgxavi.Gupcat.Data.Entities\GupcatModel.edmx
-- --------------------------------------------------

--SET QUOTED_IDENTIFIER OFF;
--GO
--USE [gupcat];
--GO
--IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
--GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_DepartamentIdentitat]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identitats] DROP CONSTRAINT [FK_DepartamentIdentitat];
GO
IF OBJECT_ID(N'[dbo].[FK_IdentitatTIP]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TIPs] DROP CONSTRAINT [FK_IdentitatTIP];
GO
IF OBJECT_ID(N'[dbo].[FK_IdentitatUsuari]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Usuaris] DROP CONSTRAINT [FK_IdentitatUsuari];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Departaments]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Departaments];
GO
IF OBJECT_ID(N'[dbo].[Identitats]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identitats];
GO
IF OBJECT_ID(N'[dbo].[TIPs]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TIPs];
GO
IF OBJECT_ID(N'[dbo].[Usuaris]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Usuaris];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Departaments'
CREATE TABLE [dbo].[Departaments] (
    [DepartamentId] int IDENTITY(1,1) NOT NULL,
    [Nom] nvarchar(max)  NOT NULL,
    [AltaData] datetime  NULL,
    [AltaUsuari] nvarchar(max)  NULL,
    [BaixaData] datetime  NULL,
    [BaixaUsuari] nvarchar(max)  NULL,
    [ModData] datetime  NULL,
    [ModUsuari] nvarchar(max)  NULL
);
GO

-- Creating table 'Identitats'
CREATE TABLE [dbo].[Identitats] (
    [IdentitatId] int IDENTITY(1,1) NOT NULL,
    [Cognom1] nvarchar(max)  NOT NULL,
    [Cognom2] nvarchar(max)  NOT NULL,
    [Nom] nvarchar(max)  NOT NULL,
    [Comentaris] nvarchar(max)  NULL,
    [AltaData] datetime  NULL,
    [AltaUsuari] nvarchar(max)  NULL,
    [BaixaData] datetime  NULL,
    [BaixaUsuari] nvarchar(max)  NULL,
    [ModData] datetime  NULL,
    [ModUsuari] nvarchar(max)  NULL,
    [DepartamentId] int  NOT NULL
);
GO

-- Creating table 'TIPs'
CREATE TABLE [dbo].[TIPs] (
    [TIPId] int IDENTITY(1,1) NOT NULL,
    [Nombre] nvarchar(max)  NOT NULL,
    [Tipus] int  NOT NULL,
    [AltaData] datetime  NULL,
    [AltaUsuari] nvarchar(max)  NULL,
    [BaixaData] datetime  NULL,
    [BaixaUsuari] nvarchar(max)  NULL,
    [ModData] datetime  NULL,
    [ModUsuari] nvarchar(max)  NULL,
    [IdentitatId] int  NOT NULL
);
GO

-- Creating table 'Usuaris'
CREATE TABLE [dbo].[Usuaris] (
    [UsuariId] int IDENTITY(1,1) NOT NULL,
    [CodiUsuari] nvarchar(max)  NOT NULL,
    [Comentaris] nvarchar(max)  NULL,
    [AltaData] datetime  NULL,
    [AltaUsuari] nvarchar(max)  NULL,
    [BaixaData] datetime  NULL,
    [BaixaUsuari] nvarchar(max)  NULL,
    [ModData] datetime  NULL,
    [ModUsuari] nvarchar(max)  NULL,
    [IdentitatId] int  NOT NULL,
    [DepartamentId] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [DepartamentId] in table 'Departaments'
ALTER TABLE [dbo].[Departaments]
ADD CONSTRAINT [PK_Departaments]
    PRIMARY KEY CLUSTERED ([DepartamentId] ASC);
GO

-- Creating primary key on [IdentitatId] in table 'Identitats'
ALTER TABLE [dbo].[Identitats]
ADD CONSTRAINT [PK_Identitats]
    PRIMARY KEY CLUSTERED ([IdentitatId] ASC);
GO

-- Creating primary key on [TIPId] in table 'TIPs'
ALTER TABLE [dbo].[TIPs]
ADD CONSTRAINT [PK_TIPs]
    PRIMARY KEY CLUSTERED ([TIPId] ASC);
GO

-- Creating primary key on [UsuariId] in table 'Usuaris'
ALTER TABLE [dbo].[Usuaris]
ADD CONSTRAINT [PK_Usuaris]
    PRIMARY KEY CLUSTERED ([UsuariId] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [IdentitatId] in table 'TIPs'
ALTER TABLE [dbo].[TIPs]
ADD CONSTRAINT [FK_IdentitatTIP]
    FOREIGN KEY ([IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_IdentitatTIP'
CREATE INDEX [IX_FK_IdentitatTIP]
ON [dbo].[TIPs]
    ([IdentitatId]);
GO

-- Creating foreign key on [IdentitatId] in table 'Usuaris'
ALTER TABLE [dbo].[Usuaris]
ADD CONSTRAINT [FK_IdentitatUsuari]
    FOREIGN KEY ([IdentitatId])
    REFERENCES [dbo].[Identitats]
        ([IdentitatId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_IdentitatUsuari'
CREATE INDEX [IX_FK_IdentitatUsuari]
ON [dbo].[Usuaris]
    ([IdentitatId]);
GO

-- Creating foreign key on [DepartamentId] in table 'Usuaris'
ALTER TABLE [dbo].[Usuaris]
ADD CONSTRAINT [FK_DepartamentUsuari]
    FOREIGN KEY ([DepartamentId])
    REFERENCES [dbo].[Departaments]
        ([DepartamentId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DepartamentUsuari'
CREATE INDEX [IX_FK_DepartamentUsuari]
ON [dbo].[Usuaris]
    ([DepartamentId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------