using fgxavi.Common.Business.Repositories;
using fgxavi.Common.Data;
using fgxavi.Common.Helpers;
using fgxavi.Gupcat.Data.Entities;
using Microsoft.Practices.Unity;
using System.Data.Entity;
using System.Web.Http;
using Unity.WebApi;

namespace fgxavi.Gupcat.Presentation.Web
{
    public static class UnityConfig
    {
        public static void RegisterComponents()
        {
            // Obt la instncia UnityContainer del procs actual.
            var container = Singleton<IUnityContainer, UnityContainer>.Instance;

            // Registra la cadena de connexi de la base de dades.
            container.RegisterType<IDbConnectionSettings, DbConnectionSettingsDomain>();
            // Registra el context de la base de dades.
            //container.RegisterType<GupcatEntities>();
            container.RegisterType<DbContext, GupcatEntities>();
            // Registra el repositori genric que accedeix a la base de dades.
            container.RegisterType(typeof(IRepository<,>), typeof(RepositoryImpl<,>));
            //// Registra el motor genric que gestiona les entitats.
            //container.RegisterType(typeof(IEngine<>), typeof(EngineImpl<>));
            //// Registra els serveis genrics de l'aplicaci.
            //container.RegisterType(typeof(IService<,>), typeof(ServiceDirectImpl<,>));
            //// Registra el traductor de les entitats i els contractes DTO.
            //container.RegisterType<ITranslator, JsonTranslator>();

            // Afegeix el contenidor UnityContainer al contenidor de dependncies de l'aplicaci Web Api
            // per a que els controlladors Web Api facin s del injector de dependncies de Unity.
            GlobalConfiguration.Configuration.DependencyResolver = new UnityDependencyResolver(container);
        }
    }
}