﻿using fgxavi.Gupcat.Data.Entities;
using System.Data.Entity;
using System.Net;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace fgxavi.Gupcat.Presentation.Web.Controllers
{
    public class IdentitatController : Controller
    {
        private GupcatEntities db = new GupcatEntities();

        // GET: /Identity/
        public ActionResult Index()
        {
            return View();
        }

        // GET: /Identity/Details/5
        public async Task<ActionResult> Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Identitat identitat = await db.Identitats.FindAsync(id);
            if (identitat == null)
            {
                return HttpNotFound();
            }
            return View(identitat);
        }

        // GET: /Identity/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: /Identity/Create
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create([Bind(Include="IdentitatId,Comentaris,AltaData,AltaUsuari,BaixaData,BaixaUsuari,ModData,ModUsuari")] Identitat identitat)
        {
            if (ModelState.IsValid)
            {
                db.Identitats.Add(identitat);
                await db.SaveChangesAsync();
                return RedirectToAction("Index");
            }

            return View(identitat);
        }

        // GET: /Identity/Edit/5
        public async Task<ActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Identitat identitat = await db.Identitats.FindAsync(id);
            if (identitat == null)
            {
                return HttpNotFound();
            }
            return View(identitat);
        }

        // POST: /Identity/Edit/5
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit([Bind(Include="IdentitatId,Comentaris,AltaData,AltaUsuari,BaixaData,BaixaUsuari,ModData,ModUsuari")] Identitat identitat)
        {
            if (ModelState.IsValid)
            {
                db.Entry(identitat).State = EntityState.Modified;
                await db.SaveChangesAsync();
                return RedirectToAction("Index");
            }
            return View(identitat);
        }

        // GET: /Identity/Delete/5
        public async Task<ActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Identitat identitat = await db.Identitats.FindAsync(id);
            if (identitat == null)
            {
                return HttpNotFound();
            }
            return View(identitat);
        }

        // POST: /Identity/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> DeleteConfirmed(int id)
        {
            Identitat identitat = await db.Identitats.FindAsync(id);
            db.Identitats.Remove(identitat);
            await db.SaveChangesAsync();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

    }
}
