﻿using fgxavi.Common.Business.Repositories;
using fgxavi.Common.Helpers;
using fgxavi.Common.Services;
using fgxavi.Gupcat.Data.Entities;
using System;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.OData;

namespace fgxavi.Gupcat.Presentation.Web.Controllers
{
    public class UsuarisController : AsyncRepositoryBaseController<Usuari, int>
    {
        public UsuarisController(IRepository<Usuari, int> repository)
            : base(repository)
        {
        }
        [HttpPost]
        public async Task<IHttpActionResult> GenerateSampleDatabase(ODataActionParameters parameters)
        {
            if (!ModelState.IsValid)
                return BadRequest();
            int total_usuaris = (int)parameters["usuaris"];
            int num_usuaris = 0;
            using (GupcatEntities dbContext = new GupcatEntities())
            {
                // Esborra tots els elements existents a la BD.
                dbContext.Usuaris.RemoveRange(dbContext.Usuaris);
                dbContext.TIPs.RemoveRange(dbContext.TIPs);
                dbContext.Identitats.RemoveRange(dbContext.Identitats);
                dbContext.Departaments.RemoveRange(dbContext.Departaments);

                //string[] roleNames = new string[]
                //{
                //    "Administrator",
                //    "Manager",
                //    "MapMaker",
                //    "Registered"
                //};
                //string roleAdministrator = roleNames[0], roleManager = roleNames[1], roleMapMaker = roleNames[2];

                string[] noms = { "Adalbert", "Adrià", "Agnès", "Agustí", "Alba", "Albert", "Alexandre", "Aleix", "Àlex", "Alfred", "Alícia", "Àlvar", "Anasti", "Anna", "Andreu", "Àngel", "Àngels", "Antoni", "Antonia", "Ariadna", "Arnau", "Artur", "Assunpció", "August", "Bartomeu", "Bernabè", "Bernardí", "Benvingut", "Bernard", "Bernat", "Beatriu", "Berta", "Biel", "Blai", "Bonaventura", "Caetà", "Camil", "Carla", "Carles", "Carme", "Carolina", "Carlota", "Cast", "Caterina", "Celestí", "Cèsar", "Cipria", "Clara", "Climent", "Constantí", "Cosme", "Cristina", "Cristià", "Cristofor", "Cristofol", "David", "Diana", "Dídac", "Dolors", "Domènec", "Donat", "Eduard", "Eliseu", "Elvira", "Emma", "Emili", "Emília", "Enric", "Ernest", "Esteve", "Estel", "Ester", "Eulàlia", "Fàtima", "Fidel", "Felicitat", "Feliu", "Felip", "Fermí", "Ferran", "Francesc", "Francesca", "Frederic", "Fructuós", "Gabriel", "Gerard", "Gonçal", "Gregori", "Guifré", "Guillem", "Hèctor", "Helena", "Heribert", "Higini", "Hipolit", "Honorat", "Hug", "Ignasi", "Immaculada", "Ireneu", "Iris", "Isabel", "Isidre", "Ivan", "Jacint", "Jaume", "Jeroni", "Joaquim", "Joel", "Jordi", "Josep", "Josepa", "Joan", "Joana", "Julià", "Júlia", "Judit", "Laia", "Lleó", "Lídia", "Llura", "Llorenç", "Luc", "Lluç", "Llúcia", "Lluís", "Lluïsa", "Lorda", "Magdalena", "Manel", "Marc", "Marçal", "Marcel", "Maria", "Mariona", "Marta", "Mateu", "Martí", "Maurici", "Mercè", "Mateu", "Maties", "Maurici", "Màxim", "Miquel", "Miquela", "Mireia", "Mònica", "Monserrat", "Montse", "Narcís", "Natàlia", "Neus", "Nicolau", "Nil", "Núria", "Oleguer", "Oriol", "Òscar", "Olga", "Pau", "Pasqual", "Paula", "Patrícia", "Pelai", "Pere", "Penèlope", "Pilar", "Pius", "Pol", "Ponç", "Prudenci", "Queralt", "Ramon", "Raquel", "Raül", "Regina", "Remei", "Ricard", "Rita", "Robert", "Roderic", "Roc", "Roger", "Rosa", "Roser", "Sanç", "Sebastià", "Segon", "Serafí", "Sergi", "Sever", "Severí", "Sílvia", "Simó", "Simeó", "Sixt", "Sofia", "Sònia", "Susanna", "Teresa", "Tecla", "Tomàs", "Valentí", "Veleri", "Valèria", "Vicent", "Vicenç", "Víctor", "Victòria", "Xavier", "Zacaries" };
                string[] cognoms = { "Abadal", "Adell", "Adserà", "Aguiló", "Agulló", "Aiats", "Aiguader", "Aiguasenosa", "Aiguaviva", "Aimamí", "Aixalà", "Alabau", "Alamà", "Alanis", "Albaigès", "Albiol", "Alboquers", "Alcover", "Alemany", "Alentorn", "Alenyar", "Ales", "Alimbau", "Aliu", "Almató", "Almirall", "Alomar", "Altaió", "Alzina", "Amades", "Amalaric", "Amill", "Amorós", "Anell", "Anglada", "Anglasell", "Anglès", "Antonijoan", "Aragall", "Arasa", "Arcarons", "Archs", "Ardiaca", "Areny", "Argemí", "Argent", "Argelaguet", "Argilaguet", "Aribau", "Arimany", "Armendares", "Armengol", "Armengou", "Arnal", "Arnau", "Arnó", "Arquer", "Arquilluer", "Arquimbau", "Arrufat", "Artigues", "Artís", "Arumí", "Arxer", "Astruells", "Auger", "Aulèstia", "Aumatell", "Auquer", "Ausàs", "Babot", "Badell", "Bacardit", "Bach", "Bachs", "Badenes", "Badia", "Badó", "Baig", "Baixench", "Balenes", "Balenyà", "Ballester", "Bancells", "Banosa", "Banyuls", "Baradot", "Bareny", "Barnils", "Baró", "Barraquer", "Barrera", "Barrufet", "Bas", "Bassegoda", "Bassó", "Bastardes", "Batet", "Batlle", "Batllori", "Bech", "Bechdejú", "Bel", "Bellprat", "Belluga", "Bellvehí", "Beltran", "Benach", "Benavent", "Benejam", "Benetó", "Bennàsser", "Bertran", "Bertranpetit", "Bertrolich", "Besaluch", "Besora", "Betí", "Bilbeny", "Billabriga", "Billés", "Blader", "Blanquer", "Bleda", "Bofarull", "Bofill", "Bohigues", "Boira", "Boix", "Boixaderes", "Boixadós", "Boixeda", "Boloix", "Bolufer", "Bonadona", "Bonal", "Bonamusa", "Bonany", "Bondia", "Bonet", "Bonjoch", "Bonnín", "Bonshoms", "Borbó", "Bori", "Borrell", "Bosc", "Bosquets", "Botifoll", "Bou", "Bover", "Bracons", "Bragulat", "Bressolí", "Bricall", "Brocà", "Brossa", "Brotons", "Brugats", "Brugatsdamunt", "Brugatsdavall", "Bruguera", "Brugulat", "Buch", "Buisac", "Bujons", "Bullich", "Cabanyes", "Cadafalch", "Cairell", "Calabuig", "Calafí", "Calbó", "Calders", "Callau", "Callicó", "Callís", "Callol", "Calsapeu", "Calvell", "Calvet", "Camafreita", "Camardons", "Camats", "Cambó", "Camilleri", "Camós", "Camp", "Campabadal", "Campalans", "Campdedéu", "Campdepadrós", "Campolier", "Campreciós", "Camprubí", "Camps", "Canadell", "Candi", "Canelies", "Canelles", "Canes", "Cantons", "Canturri", "Canut", "Canyadell", "Canyelles", "Capell", "Capellà", "Capmany", "Carandell", "Carbó", "Carbonell", "Cardellach", "Cardó", "Cardús", "Cargol", "Carner", "Carol", "Carolà", "Carratalà", "Carret", "Carreres", "Casadellà", "Casademunt", "Casadesús", "Casadevall", "Casajoana", "Casamitjana", "Casanelles", "Casanova", "Casals", "Casasses", "Casasús", "Caselles", "Caseny", "Cases", "Cassany", "Cassi", "Castany", "Castanyer", "Castell", "Castellarnau", "Castellet", "Castellot", "Castells", "Castellseguí", "Castelltort", "Castellví", "Català", "Catarineu", "Cateura", "Cava", "Cavaller", "Celis", "Cerveró", "Cirera", "Cirici", "Cisa", "Civanyan", "Civit", "Civis", "Claris", "Clavell", "Clofent", "Clop", "Clos", "Closella", "Clot", "Clotet", "Coca", "Codina", "Codonyan", "Coll", "Collbatalló", "Colldeforns", "Colldelram", "Collell", "Collelldemont", "Collmer", "Colom", "Colomer", "Cols", "Coma", "Comadran", "Comalat", "Comamala", "Comaposada", "Comes", "Comerma", "Comí", "Comorera", "Companys", "Compte", "Conill", "Conillera", "Conte", "Corb", "Corcoll", "Cordonet", "Cornet", "Coroleu", "Corredor", "Corretja", "Cors", "Cortada", "Cortès", "Cosidor", "Costa", "Cots", "Creixells", "Cresques", "Crossa", "Crosses", "Cruanyes", "Cruells", "Cucarella", "Cucurull", "Cuní", "Curull", "Cussó", "Dalmau", "Dardanyà", "Darder", "Daurella", "Daviu", "Dedéu", "Defilló", "Delclòs", "Delort", "Damians", "Dencàs", "Descàrrega", "Desumbila", "Desvalls", "Deu", "Deugràcies", "Deulofeu", "Dinarès", "Dolcet", "Dolç", "Dot", "Dunyol", "Duocastella", "Durany", "Eiximenis", "Ensenyat", "Escaiol", "Escandell", "Escarcella", "Esclasans", "Escofet", "Escòlies", "Escorcell", "Escrig", "Escrivà", "Espar", "Espelt", "Espinalt", "Espinars", "Espriu", "Esquirol", "Estalrich", "Estanyol", "Fabra", "Fabregat", "Fabregó", "Fàbregues", "Faiadell", "Fandos", "Farell", "Farinyes", "Farners", "Farriols", "Fau", "Faulí", "Fenollar", "Fermat", "Ferrà", "Ferràs", "Ferrandis", "Fibla", "Filella", "Fiter", "Fiveller", "Flequer", "Florensa", "Flotats", "Fluxa", "Foix", "Folch", "Fonoll", "Fonollà", "Fontanals", "Fontbernat", "Fontbona", "Fontova", "Fontserè", "Forcada", "Forcadell", "Formatger", "Formiguera", "Fortesa", "Franch", "Fransitorra", "Freixanet", "Freixes", "Frisach", "Fullà", "Fullana", "Fullat", "Furió", "Fuster", "Gabarró", "Gai", "Gaixet", "Gaja", "Gaju", "Galí", "Gallart", "Gallissà", "Gallofrer", "Galvany", "Gamell", "Gamonal", "Ganyet", "Garangou", "Garreta", "Garrell", "Garrigosa", "Garsaball", "Gasull", "Gatell", "Gateu", "Gaudí", "Gavaldà", "Gelats", "Gendrau", "Gener", "Germà", "Gili", "Gilibets", "Gilisbarts", "Gimbernau", "Ginebreda", "Giner", "Giraut", "Gispert", "Gistau", "Gol", "Golferich", "Gols", "Gombau", "Gomis", "Gonfaus", "Gonyalons", "Gorguí", "Gorina", "Gornals", "Grabulosa", "Granell", "Grau", "Graupera", "Griera", "Griful", "Grinyó", "Gual", "Guanyavents", "Guardans", "Guardiola", "Guarner", "Guau", "Gubern", "Güell", "Guerola", "Guia", "Guillaumet", "Guillemon", "Guim", "Guimerà", "Guinjoan", "Guinot", "Guiu", "Guix", "Guixer", "Hill", "Hortalà", "Hortolà", "Huguet", "Húnter", "Ibars", "Illa", "Inglada", "Irla", "Isern", "Isús", "Jardí", "Jaumà", "Jo", "Joandó", "Joaniquet", "Joncar", "Jordà", "Jordana", "Jounou", "Jover", "Juncadella", "Just", "Lairet", "Laporta", "Lastortras", "Letxa", "Llach", "Lladre", "Llambí", "Llambrich", "Llates", "Llauneta", "Lleget", "Lleonart", "Lletí", "Llevat", "Llidó", "Lligona", "Llobatera", "Llobell", "Llobera", "Llobet", "Llombart", "Llompart", "Llonch", "Llongueres", "Llop", "Llopis", "Llorach", "Llord", "Lloret", "Lluhí", "Llúria", "Llussà", "Luguel", "Macabies", "Macià", "Magem", "Magrinyà", "Maimó", "Mainar", "Majoral", "Malagarriga", "Mallafré", "Mallench", "Mallol", "Malonda", "Managuerra", "Manau", "Manent", "Manclús", "Marca", "Marçal", "Margarit", "Margenat", "Marginedes", "Maristany", "Marquès", "Marroig", "Mas", "Masdalmau", "Masdexeixars", "Masfort", "Masguillem", "Masoliver", "Maspons", "Masramon", "Massanet", "Massip", "Massó", "Masvidal", "Matabosc", "Mates", "Mató", "Mengual", "Mestre", "Mesull", "Micó", "Milà", "Millet", "Minguell", "Minguella", "Mir", "Mira", "Miracle", "Miralbell", "Miralles", "Miralpeix", "Mirats", "Miravitlles", "Miret", "Miró", "Miserachs", "Mitjana", "Mitjans", "Modolell", "Moles", "Moll", "Monells", "Monner", "Montanyà", "Montau", "Montellà", "Montells", "Montfulleda", "Montgai", "Montllor", "Montoliu", "Montpalau", "Montsalvatge", "Montserrat", "Moragues", "Moreu", "Morgades", "Morral", "Mosella", "Mota", "Mundó", "Muntaner", "Muntanya", "Muntanyola", "Murià", "Mut", "Nadal", "Nicou", "Nin", "Niubò", "Nomdedéu", "Noms", "Novell", "Nubiola", "Och", "Ochs", "Obiols", "Oliu", "Olivella", "Oliver", "Oller", "Om", "Oms", "Oranich", "Ordeig", "Ordeix", "Oristrell", "Oró", "Orriols", "Ors", "Ortells", "Ortiga", "Orts", "Pach", "Pagès", "Paimada", "Palau", "Palet", "Pallach", "Pallerola", "Panyella", "Papasseit", "Parera", "Paretes", "Parra", "Parramon", "Parramona", "Paulí", "Paüls", "Pausà", "Pedra", "Pedrol", "Pedrola", "Pedrolo", "Peguera", "Pei", "Peig", "Peix", "Pelegero", "Pella", "Pellicena", "Pellicer", "Peralta", "Peramartí", "Perarnau", "Perdigó", "Perdrix", "Perejoan", "Perera", "Peris", "Permanyer", "Petit", "Petitbo", "Petràs", "Pi", "Pibernat", "Picanyol", "Picó", "Picornell", "Pidecabanyes", "Pidelaserra", "Piferrer", "Pigem", "Pigrau", "Pijoan", "Pina", "Pineda", "Pintat", "Pinya", "Pinyol", "Piques", "Pla", "Plandolit", "Planelles", "Planxart", "Poal", "Poch", "Pomar", "Pomers", "Pontjoan", "Porcel", "Porta", "Pou", "Pous", "Prat", "Pratdesaba", "Pratginestós", "Prats", "Prenafeta", "Prim", "Pruna", "Pubill", "Pucurella", "Pucurull", "Puig", "Puigbò", "Puigcercós", "Puigcerdà", "Puigcorber", "Puigdecabanes", "Puigdefàbregues", "Puigdelabellacasa", "Puigdellívol", "Puigdemassa", "Puigdemont", "Puigdengoles", "Puigdevall", "Puigdollers", "Puigdomènech", "Puigferrer", "Puiggarí", "Puigivila", "Puigpelat", "Puigserver", "Puigsesllosses", "Puigtobella", "Puigverd", "Puigxoriguer", "Pujades", "Pujals", "Pujol", "Pujols", "Puxeu", "Quadreny", "Queixal", "Quera", "Qui", "Quixal", "Rabell", "Rabella", "Rabionet", "Rafanell", "Ràfols", "Rahola", "Ramis", "Ras", "Raspall", "Rata", "Rebull", "Recasens", "Recatalà", "Recoder", "Rectoret", "Remolar", "Renom", "Renyer", "Reig", "Reiners", "Reixach", "Reixachdamunt", "Reixachdavall", "Revelles", "Reventós", "Reverter", "Revés", "Riba", "Ribalta", "Ribelles", "Ribot", "Ricou", "Ridao", "Riembau", "Riera", "Rieradevall", "Rifà", "Rigau", "Rimbau", "Rissech", "Riudor", "Riutort", "Rocabert", "Rocabertí", "Rocafort", "Rocasalva", "Rodelles", "Rodorera", "Roglà", "Roig", "Roïra", "Roís", "Rom", "Romaní", "Romeva", "Rosdevall", "Rossell", "Rossinyol", "Rota", "Roure", "Rovira", "Roviralta", "Rovirosa", "Rubau", "Rubinat", "Rubió", "Ruïch", "Rutllant", "Sabarís", "Saber", "Saborit", "Sablich", "Sacirera", "Sala", "Saladrigues", "Salom", "Salort", "Salrach", "Saltor", "Salvà", "Salvany", "Salvat", "Salvatella", "Samaranch", "Samper", "Samsó", "Sanabre", "Santaeulàlia", "Santceloni", "Santllehí", "Santpere", "Santromà", "Sanxis", "Sardiner", "Sarrà", "Sarsanedes", "Saura", "Sauret", "Secanella", "Segimon", "Seguí", "Segura", "Seix", "Sellarès", "Selva", "Senespleda", "Senserrich", "Senties", "Sentís", "Serarols", "Serentill", "Serracant", "Serradelarca", "Serradesanferm", "Serrahima", "Serrallach", "Serrarols", "Serrat", "Serrats", "Seuba", "Siberta", "Sicart", "Sindreu", "Singla", "Sinyol", "Siscar", "Sistach", "Sobirana", "Sobirats", "Sobiratsdamunt", "Sobiratsdavall", "Sobregrau", "Sobrequés", "Soldevila", "Solei", "Soler", "Solivelles", "Soquer", "Sorribes", "Sospedra", "Suai", "Suau", "Sudrià", "Sugranyes", "Sunyer", "Sunyol", "Surinyach", "Suriol", "Surrallès", "Surroca", "Taix", "Tallada", "Tallaferro", "Tamarit", "Tàpies", "Tarongí", "Tarradelles", "Tarroja", "Tasis", "Tauler", "Taurinyà", "Tei", "Tell", "Terrafeta", "Ticó", "Timoneda", "Togores", "Toldrà", "Tolrà", "Torra", "Tornafoch", "Torregrossa", "Torrendell", "Torroglosa", "Tort", "Traguany", "Trèmols", "Tremosa", "Trenchs", "Triadú", "Tries", "Trinxet", "Trueta", "Trullols", "Turell", "Turró", "Turull", "Tutusaus", "Urpià", "Ullastre", "Usac", "Vallcorba", "Valldaura", "Valleriola", "Vallescà", "Vallplana", "Vallribera", "Vallverdú", "Valor", "Veguer", "Veiret", "Ventalló", "Ventosa", "Ventura", "Verdaguer", "Verdeny", "Vergós", "Vericat", "Viciana", "Vidagany", "Vidal ", "Vila", "Viladelprat", "Viladevall", "Viladoms", "Viladot", "Vilajosana", "Vilalba", "Vilalta", "Vilaplana", "Vilar", "Vilarasau", "Vilardaga", "Vilardebò", "Vilardell", "Vilarrasa", "Vinagre", "Vinyals", "Vinyeta", "Vinyoles", "Virgili", "Viu", "Viusà", "Vivet", "Vives", "Xammar", "Xampeny", "Xandri", "Xatard", "Xaus", "Xauvell", "Xercavins", "Xicoi", "Xicola", "Xinxilla", "Xinxò", "Xipell", "Xirau", "Xirgu", "Xirinachs", "Xoriguera", "Xuclà", "Xufré" };
                string[] departaments = { "Generalitat de Catalunya", "President de la Generalitat", "Parlament de Catalunya", "Consell de Garanties Estatutàries", "Síndic de Greuges de Catalunya", "Sindicatura de Comptes de Catalunya", "Oficina Antifrau de Catalunya", "Departament de la Presidència", "Departament de Governació i Relacions Institucionals", "Departament d'Economia i Coneixement", "Departament d'Ensenyament", "Departament de Salut", "Departament d'Interior", "Departament de Territori i Sostenibilitat", "Departament de Cultura", "Departament d'Agricultura, Ramaderia, Pesca, Alimentació i Medi Natural", "Departament de Benestar Social i Família", "Departament d'Empresa i Ocupació", "Departament de Justícia", "Autoritat Catalana de Protecció de Dades", "Comissió Jurídica Assessora", "Institut Català Internacional per la Pau (ICIP)", "Consell de Treball, Econòmic i Social de Catalunya", "Consell de l'Audiovisual de Catalunya (CAC)", "Consell Assessor de Ràdio i Televisió Espanyola (RTVE) a Catalunya", "Corporació Catalana de Mitjans Audiovisuals", "Òrgan Administratiu de Recursos Contractuals de Catalunya", "Organismes amb Número d'Identificació Fiscal" };
                string department_admin = "Unitat de Gestió d'Usuaris";
                string user_admin = "admin";
                //string commonPassword = "holahola", commonPasswordQuestion = "Salutació", commonPasswordAnswer = "holahola";

                Random rnd = new Random();
                var date = DateTime.Now;

                #region Genera el departament dels administradors
                {
                    date = DateTime.Now;
                    Departament departament = new Departament()
                    {
                        Nom = department_admin,
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Departaments.Add(departament);

                #endregion

                #region Genera l'usuari administrador

                    // Crea la identitat del usuari administrador
                    Identitat pf = new Identitat()
                    {
                        Nom = noms[rnd.Next(noms.Length)],
                        Cognom1 = cognoms[rnd.Next(cognoms.Length)],
                        Cognom2 = cognoms[rnd.Next(cognoms.Length)],
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Identitats.Add(pf);
                    // Crea una targeta d'identitat per l'usuari administrador
                    TIP tip = new TIP()
                    {
                        Nombre = new NIF().Random,
                        Tipus = 1,
                        Identitat = pf,
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.TIPs.Add(tip);
                    // Crea l'usuari administrador
                    Usuari user = new Usuari()
                    {
                        Identitat = pf,
                        CodiUsuari = user_admin,
                        Comentaris = "Usuari administrador.",
                        // Obté aleatòriament un departament
                        Departament = departament,
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Usuaris.Add(user);
                }
                #endregion

                #region Genera tots els departaments

                foreach (var nom in departaments)
                {
                    date = DateTime.Now;
                    Departament departament = new Departament()
                    {
                        Nom = nom,
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Departaments.Add(departament);
                }

                #endregion

                // S'apliquen els canvis dels entities a la base de dades de forma asíncrona
                // per poder utilitzar l'assignació de departaments aleatòria sobre els usuaris
                // d'altra manera l'entity framework no crea correctament els usuaris degut a la consulta amb Linq.
                await dbContext.SaveChangesAsync();

                #region Genera tots els usuaris de proves

                for (int i = 1; i < total_usuaris; i++)
                {
                    date = DateTime.Now;
                    // Crea les identitats dels usuaris
                    Identitat pf = new Identitat()
                    {
                        Nom = noms[rnd.Next(noms.Length)],
                        Cognom1 = cognoms[rnd.Next(cognoms.Length)],
                        Cognom2 = cognoms[rnd.Next(cognoms.Length)],
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Identitats.Add(pf);
                    // Crea una targeta d'identitat per cada persona
                    TIP tip = new TIP()
                    {
                        Nombre = new NIF().Random,
                        Tipus = 1,
                        Identitat = pf,
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.TIPs.Add(tip);
                    //// Crea un usuari per a cada identitat
                    Usuari user = new Usuari()
                    {
                        Identitat = pf,
                        CodiUsuari = string.Format("{0}.{1}.{2}", pf.Nom, pf.Cognom1, pf.Cognom2),
                        Comentaris = string.Format("Usuari de prova núm. {0}.", i),
                        // Obté aleatòriament un departament
                        Departament = dbContext.Departaments
                        .OrderBy(x => Guid.NewGuid()).FirstOrDefault(),
                        AltaData = date,
                        AltaUsuari = user_admin,
                        ModData = date,
                        ModUsuari = user_admin
                    };
                    dbContext.Usuaris.Add(user);
                    //// Crea una subscripció per a cada usuari
                    //string passwordSalt = HashHelper.CreateRandomSalt();
                    //string passwordAnswerSalt = HashHelper.CreateRandomSalt();
                    //Membership member = new Membership()
                    //{
                    //    User = user,
                    //    Email = string.Format("{0}@gencat.cat", user.UserName),
                    //    PasswordHash = HashHelper.ComputeSaltedHash(() => commonPassword, passwordSalt),
                    //    PasswordSalt = passwordSalt,
                    //    PasswordQuestion = commonPasswordQuestion,
                    //    PasswordAnswerHash = HashHelper.ComputeSaltedHash(() => commonPasswordAnswer, passwordAnswerSalt),
                    //    PasswordAnswerSalt = passwordAnswerSalt
                    //};
                    //dbContext.Memberships.Add(member);

                    // S'apliquen els canvis dels entities a la base de dades de forma asíncrona.
                    await dbContext.SaveChangesAsync();
                }

                #endregion

                // S'apliquen els canvis dels entities a la base de dades de forma asíncrona.
                await dbContext.SaveChangesAsync();

                // S'obté la quantitat d'usuaris generats.
                num_usuaris = dbContext.Usuaris.Count();
            }
            // Es retorna la quantitat d'usuaris generats.
            return Ok(num_usuaris);
        }
    }
}
