﻿//#region Creació dels espais de noms
var explorer = explorer || {};
explorer.constants = explorer.constants || {};
explorer.constants.paged = explorer.constants.paged || {};
explorer.helpers = explorer.helpers || {};
explorer.helpers.paged = explorer.helpers.paged || {};
explorer.classes = explorer.classes || {};
explorer.classes.paged = explorer.classes.paged || {};
//#endregion

//#region Informació de la Versió
explorer.version = "1.0.0";
explorer.developer = "fgxavi";
//#endregion

//#region Constants
explorer.constants.queryTimeout = 30 * 1000;
explorer.constants.displayErrorMessageDuration = 20 * 1000;
explorer.constants.paged.defaultTop = 10;
explorer.constants.paged.maxTop = 100;
explorer.constants.paged.defaultPageSizeOptions = [5, 10, 25, 50, 100];
explorer.constants.paged.defaultMaxRange = 3;
explorer.constants.paged.defaultTypeOfNavigator = '#';
//explorer.constants.sorted.direction.ascending = 'asc';
//explorer.constants.sorted.direction.descending = 'desc';
//#endregion

//#region Helpers

explorer.helpers.DateTime = explorer.helpers.DateTime ||
    // Funció que converteix una cadena de text amb estàndard UTC de DateTime a un format familiar.
    function (datetime) {
        var dt = new Date(datetime);
        //var str = ''.match('');
        //dt.getFullYear() + '/' dt.ge
        //var d = dt.toDateString('YYYY-MM-DD');//.match('[0-9]{2}:[0-9]{2}:[0-9]{2}');
        //var t = dt.toTimeString().match('[0-9]{2}:[0-9]{2}:[0-9]{2}');
        return dt.toLocaleString();
    }


//#region ListViewHelper
explorer.helpers.ColumnsConstructor = explorer.helpers.ColumnsConstructor ||
    // Funció que construeix un array observable de camps.
    function (names, displayNames) {
        var columns = ko.observableArray([]);
        var length = Math.min(names.length, displayNames.length);
        for (var i = 0; i < length; i++) {
            var field = new explorer.classes.Column(names[i], displayNames[i]);
            columns().push(field);
        }
        return columns;
    }
//#endregion

//#region ListViewPagedHelper
explorer.helpers.paged.PageCount = explorer.helpers.paged.PageCount ||
    /// <summary>
    /// Obté el nombre total de pàgines.
    /// </summary>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Nombre de pàgines.</returns>
    function (pageSize, totalItemCount) {
        if (pageSize === 0)
            return null;
        return Math.ceil(totalItemCount / pageSize);
    };
explorer.helpers.paged.NormalizeItem = explorer.helpers.paged.NormalizeItem ||
    /// <summary>
    /// Corregeix un índex d'element incorrecte.
    /// </summary>
    /// <param name="item">Índex d'element sense verificar.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Índex d'element vàlid.</returns>
    function (item, totalItemCount) {
        return Math.max(Math.min(item, totalItemCount), 1);
    };
explorer.helpers.paged.NormalizePage = explorer.helpers.paged.NormalizePage ||
    /// <summary>
    /// Corregeix un índex de pàgina incorrecte.
    /// </summary>
    /// <param name="pageNumber">Índex de pàgina sense verificar.</param>
    /// <param name="pageCount">Nombre total de pàgines.</param>
    /// <returns>Índex de pàgina vàlid.</returns>
    function (pageNumber, pageCount) {
        return Math.max(Math.min(pageNumber, pageCount), 1);
    };
explorer.helpers.paged.NormalizePage = explorer.helpers.paged.NormalizePage ||
    /// <summary>
    /// Corregeix un índex de pàgina incorrecte.
    /// </summary>
    /// <param name="item">Índex de pàgina sense verificar.</param>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Índex de pàgina vàlid.</returns>
    function (pageNumber, pageSize, totalItemCount) {
        var pageCount = PageCount(pageSize, totalItemCount);
        return NormalizePage(pageNumber, pageCount);
    };
explorer.helpers.paged.FirstItemOnPage = explorer.helpers.paged.FirstItemOnPage ||
    /// <summary>
    /// Calcula l'índex del primer element de la pàgina actual.
    /// </summary>
    /// <param name="pageNumber">Pàgina actual.</param>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Índex del primer element de la pàgina actual.</returns>
    function (pageNumber, pageSize, totalItemCount) {
        return totalItemCount === 0 ? null : Math.max(1, (pageNumber - 1) * pageSize + 1);
    };
explorer.helpers.paged.LastItemOnPage = explorer.helpers.paged.LastItemOnPage ||
    /// <summary>
    /// Calcula l'índex de l'últim element de la pàgina actual.
    /// </summary>
    /// <param name="pageNumber">Pàgina actual.</param>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Índex de l'últim element de la pàgina actual.</returns>
    function (pageNumber, pageSize, totalItemCount) {
        return totalItemCount === 0 ? null : Math.min(totalItemCount, pageNumber * pageSize - 1);
    };
explorer.helpers.paged.ItemsOnPage = explorer.helpers.paged.ItemsOnPage ||
    /// <summary>
    /// Obté els índex dels elements de la pàgina actual.
    /// </summary>
    /// <param name="pageNumber">Pàgina actual.</param>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <returns>Índex del primer element de la pàgina actual.</returns>
    function (pageNumber, pageSize, totalItemCount) {
        var min = self.FirstItemOnPage(pageNumber, pageSize, totalItemCount);
        var max = self.LastItemOnPage(pageNumber, pageSize, totalItemCount);
        var items = [];
        if (min !== null && max !== null)
            for (i = min; i <= max; i++)
                items.push(i);
        return items;
    };
explorer.helpers.paged.RangeNavigator = explorer.helpers.paged.RangeNavigator ||
    /// <summary>
    /// Obté un array d'enters amb l'interval de pàgines del navegador.
    /// </summary>
    /// <param name="pageNumber">Pàgina actual.</param>
    /// <param name="pageCount">Nombre total de pàgines.</param>
    /// <param name="maxRange">Nombre màxim de pàgines del rang.</param>
    /// <returns>Array d'enters amb l'interval de pàgines del navegador.</returns>
    function (pageNumber, pageCount, maxRange) {
        var interval = [];
        var min = Math.max(Math.floor(pageNumber / maxRange) * maxRange - 1, 1);
        var max = Math.min((Math.floor(pageNumber / maxRange) + 1) * maxRange, pageCount);
        for (i = min; i <= max; i++)
            interval.push(i);
        return interval;
    };
explorer.helpers.paged.RangeNavigator = explorer.helpers.paged.RangeNavigator ||
    /// <summary>
    /// Obté un array d'enters amb l'interval de pàgines del navegador.
    /// </summary>
    /// <param name="pageNumber">Pàgina actual.</param>
    /// <param name="pageSize">Mida de les pàgines.</param>
    /// <param name="totalItemCount">Nombre total d'elements.</param>
    /// <param name="maxRange">Nombre màxim de pàgines del rang.</param>
    /// <returns>Array d'enters amb l'interval de pàgines del navegador.</returns>
    function (pageNumber, pageSize, totalItemCount, maxRange) {
        var pageCount = self.PageCount(pageSize, totalItemCount);
        return RangeNavigator(pageNumber, pageCount, maxRange);
    };
explorer.helpers.paged.LeftNavigator = explorer.helpers.paged.LeftNavigator ||
    /// <summary>
    /// Obté la pàgina de navegació per l'esquerra a un altre rang de pàgines.
    /// </summary>
    /// <param name="rangeNavigator">Array d'enters amb l'interval de pàgines del navegador.</param>
    /// <returns>Pàgina de navegació a l'esquerra o nul si no n'hi ha.</returns>
    function (rangeNavigator) {
        if (rangeNavigator === null || rangeNavigator.length === 0)
            return null;
        var left = rangeNavigator[0];
        return left > 1 ? left : null;
    };
explorer.helpers.paged.RightNavigator = explorer.helpers.paged.RightNavigator ||
    /// <summary>
    /// Obté la pàgina de navegació per la dreta a un altre rang de pàgines.
    /// </summary>
    /// <param name="rangeNavigator">Array d'enters amb l'interval de pàgines del navegador.</param>
    /// <param name="pageCount">Nombre total de pàgines.</param>
    /// <returns>Pàgina de navegació a la dreta o nul si no n'hi ha.</returns>
    function (rangeNavigator, pageCount) {
        if (rangeNavigator === null || rangeNavigator.length === 0)
            return null;
        var right = rangeNavigator[rangeNavigator.length - 1];
        return right < pageCount ? right : null;
    };
//#endregion

//#region ListViewSortedHelper
//#endregion

//#endregion

///#region Classes

explorer.classes.Column = explorer.classes.Column ||
    // Classe que construeix un camp.
    function (name, displayName, type, visible, direction, order) {
        var self = this;

        //#region Field
        /// <summary>
        /// Nom del camp.
        /// </summary>
        self.Name = ko.observable(name);
        /// <summary>
        /// Nom visualitzable del camp.
        /// </summary>
        self.DisplayName = ko.observable(displayName);
        /// <summary>
        /// Tipus de dades del camp. Per defecte és string.
        /// </summary>
        self.Type = ko.observable(type || 'string');
        /// <summary>
        /// Visibilitat del camp. Un camp invisible no es tindrà en compte.
        /// </summary>
        self.Visible = ko.observable(visible || true);
        //#endregion

        //#region SortedField
        /// <summary>
        /// Direcció d'ordenació del camp.
        /// 0 no ordena el camp, 1 és ascendent i 2 és descendent.
        /// </summary>
        self.Direction = ko.observable(direction || 0);
        /// <summary>
        /// Ordre del camp respecte la resta de camps ordenats.
        /// </summary>
        self.Order = ko.observable(order || -1);
        /// <summary>
        /// Canvia la direcció d'ordenació del camp.
        /// </summary>
        self.ChangeDirection = function () {
            var direction = self.Direction();
            self.Direction(direction != 1 ? 1 : 2);
        }
        /// <summary>
        /// Canvia l'estat d'ordenació del camp.
        /// </summary>
        self.ChangeState = function () {
            var direction = self.Direction();
            if (direction === 0)
                self.Order(0);
            self.Direction(direction > 1 ? 0 : direction + 1);
        }
        //#endregion

    }

explorer.classes.ListViewModel = explorer.classes.ListViewModel ||
    // Classe que construeix els paràmetres de paginació d'una consulta.
    function (columns, pageSize, pageSizeOptions, maxRange, typeOfNavigator) {
        var self = this;

        //#region IListView
        /// <summary>
        /// Llista de camps.
        /// </summary>
        self.Columns = ko.observableArray([]);
        columns = columns || [];
        for (var i = 0; i < columns.length; i++) {
            self.Columns.push(new explorer.classes.Column(
                columns[i].Name,
                columns[i].DisplayName,
                columns[i].Type,
                columns[i].Visible,
                columns[i].Direction,
                columns[i].Order
                ));
        }
        /// <summary>
        /// Llista d'elements amb permisos exclusius de lectura.
        /// </summary>
        self.Items = ko.observableArray([]);
        //#endregion

        //#region ISortedListView
        self.SortedColumns = ko.observableArray([]);
        var columnsSortedSubscriptions = [];
        var rebuildSorted = function () {
            while (columnsSortedSubscriptions.length > 0)
                columnsSortedSubscriptions.pop().dispose();
            var columns = self.Columns();
            for (var i = 0; i < columns.length; i++) {
                columnsSortedSubscriptions.push(
                    columns[i].Direction.subscribe(function () {
                        this.Columns.notifySubscribers();
                    }, self));
                columnsSortedSubscriptions.push(
                    columns[i].Order.subscribe(function () {
                        this.SortedColumns.notifySubscribers();
                    }, self));
            }
            var sorted = columns
                .filter(function (col) { return col.Direction() > 0 })
                .sort(function (a, b) { return a.Order() > b.Order() });
            self.SortedColumns(sorted);
        };
        var orderSorted = function () {
            var sorted = self.SortedColumns();
            for (var i = 0; i < sorted.length; i++)
                sorted[i].Order(i + 1);
        };
        self.Columns.subscribe(rebuildSorted);
        self.SortedColumns.subscribe(orderSorted);
        self.Columns.notifySubscribers();
        //#endregion

        //#region IPagedListView
        self.TotalItemCount = ko.observable(0);
        self.PageSize = ko.observable(pageSize || explorer.constants.paged.defaultTop);
        self.PageNumber = ko.observable(1);
        self.PageCount = ko.computed(function () {
            var count = explorer.helpers.paged
                .PageCount(this.PageSize(), this.TotalItemCount()) || 1;
            this.PageNumber(Math.max(Math.min(this.PageNumber(), count), 1));
            return count;
        }, self);
        //#endregion

        //#region IListViewPaginator
        /// <summary>
        /// Opcions amb el nombre d'elements per pàgina.
        /// </summary>
        self.PageSizeOptions = ko.observable(pageSizeOptions
            || explorer.constants.paged.defaultPageSizeOptions);
        /// <summary>
        /// Indicador de pàgines posteriors (automàtic).
        /// </summary>
        self.HasNextPage = ko.computed(function () {
            return this.PageNumber() < this.PageCount();
        }, self);
        /// <summary>
        /// Indicador de pàgines anteriors (automàtic).
        /// </summary>
        self.HasPreviousPage = ko.computed(function () {
            return this.PageNumber() > 1;
        }, self);
        /// <summary>
        /// Indicador de primera pàgina (automàtic).
        /// </summary>
        self.IsFirstPage = ko.computed(function () {
            return this.PageNumber() <= 1;
        }, self);
        /// <summary>
        /// Indicador d'última pàgina (automàtic).
        /// </summary>
        self.IsLastPage = ko.computed(function () {
            return this.PageNumber() >= this.PageCount();
        }, self);
        /// <summary>
        /// Indicador de segona pàgina (automàtic).
        /// </summary>
        self.IsSecondPage = ko.computed(function () {
            return this.PageNumber() === 2;
        }, self);
        /// <summary>
        /// Indicador de penúltima pàgina (automàtic).
        /// </summary>
        self.IsPenultimatePage = ko.computed(function () {
            return this.PageNumber() === this.PageCount() - 1;
        }, self);
        /// <summary>
        /// Índex del primer element de la pàgina actual (automàtic).
        /// </summary>
        self.FirstItem = ko.computed(function () {
            return explorer.helpers.paged.FirstItemOnPage(this.PageNumber(),
                this.PageSize(), this.TotalItemCount());
        }, self);
        /// <summary>
        /// Índex de l'últim element de la pàgina actual (automàtic).
        /// </summary>
        self.LastItem = ko.computed(function () {
            return explorer.helpers.paged.LastItemOnPage(this.PageNumber(),
                this.PageSize(), this.TotalItemCount());
        }, self);
        //#endregion

        //#region IListViewNavigator
        /// <summary>
        /// Nombre màxim de pàgines del rang seleccionable on pertany la pàgina actual.
        /// </summary>
        self.MaxRange = ko.observable(maxRange || explorer.constants.paged.defaultMaxRange);
        /// <summary>
        /// Array d'enters amb l'interval de pàgines del navegador.
        /// </summary>
        self.Range = ko.computed(function () {
            return explorer.helpers.paged.RangeNavigator(this.PageNumber(),
                this.PageCount(), this.MaxRange());
        }, self);
        /// <summary>
        /// Pàgina de navegació a l'esquerra o nul si no n'hi ha.
        /// </summary>
        self.LeftNavigator = ko.computed(function () {
            return explorer.helpers.paged.LeftNavigator(this.Range());
        }, self);
        /// <summary>
        /// Pàgina de navegació a la dreta o nul si no n'hi ha.
        /// </summary>
        self.RightNavigator = ko.computed(function () {
            return explorer.helpers.paged.RightNavigator(this.Range(), this.PageCount());
        }, self);
        /// <summary>
        /// Tipus de navegador de pàgines que es visualitza.
        /// </summary>
        self.TypeOfNavigator = ko.observable(typeOfNavigator || explorer.constants.paged.defaultTypeOfNavigator);
        //#endregion

        //#region IQueryOptions
        self.QueryOptions = ko.observable();

        //#region IPagedQueryOptions
        self.Top = self.PageSize;
        self.Skip = ko.computed(function () {
            return (this.PageNumber() - 1) * this.PageSize();
        }, self);
        //#endregion

        //#region IConstrainedQueryOptions
        self.GlobalSearch = ko.observable('');
        //#endregion

        //#endregion

    }

explorer.classes.ODataFactory = explorer.classes.ODataFactory ||
    // Classe amb la configuració necessària per proveir servei amb una font de dades OData.
    {
        QueryOptions:
            {
                QueryBuilder: function (qo) {
                    var parameters = []
                        .concat(qo.ConstrainedParameters())
                        .concat(qo.PagedParameters())
                        .concat(qo.SortedParameters());
                    var subqueries = [];
                    for (var i = 0; i < parameters.length; i++)
                        subqueries.push('$' + parameters[i].Key + '=' + parameters[i].Value);
                    var query = subqueries.join("&", subqueries);
                    return query;
                },
                PagedParametersBuilder: function (vm) {
                    var parameters = [];
                    parameters.push({ Key: 'inlinecount', Value: 'allpages' });
                    var topValid = vm.Top() === null || vm.Top() < 0 || vm.Top() > explorer.constants.paged.maxTop
                        ? explorer.constants.paged.defaultTop : vm.Top();
                    parameters.push({ Key: 'top', Value: topValid });
                    var skipValid = vm.Skip() === null || vm.Skip() < 0 ? 0 : vm.Skip();
                    if (skipValid > 0)
                        parameters.push({ Key: 'skip', Value: skipValid });
                    return parameters;
                },
                SortedParametersBuilder: function (vm) {
                    var sorted = vm.SortedColumns();
                    if (sorted.length == 0)
                        return [];
                    var directions = [];
                    for (var i = 0; i < sorted.length; i++)
                        directions.push(sorted[i].Name()
                            + (sorted[i].Direction() === 2 ? ' desc' : ' asc'));
                    var value = directions.join(',');
                    var parameters = [ { Key: 'orderby', Value: value } ];
                    return parameters;
                },
                ConstrainedParametersBuilder: function (vm) {
                    var search = vm.GlobalSearch();
                    var constraints = [];
                    if (search != '')
                    {
                        var constraintsSearch = [];
                        var columns = vm.Columns()
                            .filter(function (col) { return col.Type() === 'string' });
                        for (var i = 0; i < columns.length; i++)
                            constraintsSearch.push('substringof(\'' + search + '\',' + columns[i].Name() + ') eq true');
                        var parameterSearch = '(' + constraintsSearch.join(' or ') + ')';
                        constraints.push(parameterSearch);
                    }
                    var value = constraints.join(' and ');
                    var parameters = [];
                    if (value != '')
                        parameters.push({ Key: 'filter', Value: value });
                    return parameters;
                }
            },
        ConnectionBuilder: function (source, qo) {
            var connection = source + '?' + qo.Query();
            return connection;
        },
        Connector: function (connection, vm) {
            $.getJSON(connection, function (data) {
                vm.TotalItemCount($(data).attr('odata.count'));
                vm.Items(data.value);
            });
        }
    }

explorer.classes.TestFactory = explorer.classes.TestFactory ||
    // Classe amb la configuració necessària per proveir servei amb una font de dades d'exemple.
    {
        QueryOptions: explorer.classes.ODataFactory.QueryOptions,
        ConnectionBuilder: explorer.classes.ODataFactory.ConnectionBuilder,
        Connector: function (connection) {
            this.vm().TotalItemCount(10);
            var items =
[{
    "IdentitatId": 497,
    "Cognom1": "Filella",
    "Cognom2": "Soquer",
    "Nom": "Ester"
},
{
    "IdentitatId": 498,
    "Cognom1": "Billés",
    "Cognom2": "Llauneta",
    "Nom": "Monserrat"
},
{
    "IdentitatId": 499,
    "Cognom1": "Surroca",
    "Cognom2": "Bragulat",
    "Nom": "Bernard"
},
{
    "IdentitatId": 500,
    "Cognom1": "Maimó",
    "Cognom2": "Gimbernau",
    "Nom": "Elvira"
},
{
    "IdentitatId": 501,
    "Cognom1": "Hortalà",
    "Cognom2": "Pei",
    "Nom": "Mateu"
},
{
    "IdentitatId": 502,
    "Cognom1": "Espelt",
    "Cognom2": "Sobirats",
    "Nom": "Ricard"
},
{
    "IdentitatId": 503,
    "Cognom1": "Usac",
    "Cognom2": "Callís",
    "Nom": "Mateu"
},
{
    "IdentitatId": 504,
    "Cognom1": "Espriu",
    "Cognom2": "Puigferrer",
    "Nom": "Veleri"
},
{
    "IdentitatId": 505,
    "Cognom1": "Bach",
    "Cognom2": "Maristany",
    "Nom": "Susanna"
},
{
    "IdentitatId": 506,
    "Cognom1": "Surinyach",
    "Cognom2": "Vilarrasa",
    "Nom": "Cristofol"
}
];
            this.vm().Items(items);
        }
    }

explorer.classes.Provider = explorer.classes.Provider ||
    // Classe que implementa tota la lògica de negoci del ListViewModel.
    function (source, factory, columns, pageSize, pageSizeOptions, maxRange, typeOfNavigator) {
        var self = this;
        // Estableix la factoria OData en cas de no especificar-se'n cap.
        factory = factory || explorer.classes.ODataFactory;
        /// <summary>
        /// ViewModel de la llista obtinguda de la font de dades.
        /// </summary>
        self.vm = ko.observable(new explorer.classes.ListViewModel(columns, pageSize, pageSizeOptions, maxRange, typeOfNavigator));
        /// <summary>
        /// Font base d'on s'obtenen els elements de l'enumeració.
        /// </summary>
        self.Source = ko.observable(source);
        /// <summary>
        /// Paràmetres de consulta d'una font de dades.
        /// </summary>
        self.QueryOptions = factory.QueryOptions;
        self.QueryOptions.Source = self.Source;
        self.QueryOptions.ConstrainedParameters = ko.computed(function () {
            return this.QueryOptions.ConstrainedParametersBuilder(this.vm());
        }, self);
        self.QueryOptions.PagedParameters = ko.computed(function () {
            return this.QueryOptions.PagedParametersBuilder(this.vm());
        }, self);
        self.QueryOptions.SortedParameters = ko.computed(function () {
            return this.QueryOptions.SortedParametersBuilder(this.vm());
        }, self);
        self.QueryOptions.Query = ko.computed(function () {
            return this.QueryOptions.QueryBuilder(this.QueryOptions);
        }, self);
        // Enllaça les opcions de consulta al ViewModel per fer-les accessibles.
        self.vm().QueryOptions(self.QueryOptions);
        /// <summary>
        /// Funció que construeix la connexió amb la font de dades.
        /// </summary>
        self.ConnectionBuilder = ko.observable(factory.ConnectionBuilder);
        /// <summary>
        /// Connexió preparada per establir comunicació amb la font de dades.
        /// </summary>
        self.Connection = ko.computed(function () {
            return this.ConnectionBuilder()(this.Source(), this.QueryOptions);
        }, self);
        self.QueryOptions.Connection = self.Connection;
        /// <summary>
        /// Funció que obté elements enumerats a partir d'una connexió.
        /// </summary>
        self.Connector = ko.observable(factory.Connector);
        self.Connectting = ko.computed(function () {
            this.Connector().call(this, this.Connection(), this.vm());
        }, self);
    }

//#endregion
