﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Http.OData.Builder;
using fgxavi.Gupcat.Data.Entities;
using System.Web.Http.OData.Query;

namespace fgxavi.Gupcat.Services.WebApiOData
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            var queryAttribute = new QueryableAttribute()
            {
                //AllowedQueryOptions = AllowedQueryOptions.Top | AllowedQueryOptions.Skip,
                PageSize = 10
            };

            config.EnableQuerySupport(queryAttribute);
            
            // Web API configuration and services
            ODataConventionModelBuilder builder = new ODataConventionModelBuilder();
            builder.EntitySet<TIP>("TIP");
            //builder.EntitySet<PersonaFisica>("PersonaFisica");
            //builder.EntitySet<PersonaJuridica>("PersonaJuridica");
            builder.EntitySet<Identitat>("Identitat");

            // Web API routes
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );

            config.Routes.MapODataRoute("odata", "odata", builder.GetEdmModel());
        }
    }
}
