﻿
using System.Collections.Generic;
namespace fgxavi.ListView
{
    /// <summary>
    /// Model que parametritza les plantilles d'un ListView
    /// per renderitzar la vista parcial en Razor.
    /// </summary>
    public class ListViewMvcTemplate
    {
        //public ListViewMvcTemplate(string Template, IColumn Columns)
        //{
        //    this.Template = Template;
        //    this.Columns = Columns;
        //}
        /// <summary>
        /// Camps visibles pel ListView.
        /// </summary>
        public IColumn[] Columns { get; set; }
        /// <summary>
        /// Nom del contenidor HTML on s'inclourà el ListView.
        /// </summary>
        public string Template { get; set; }
        /// <summary>
        /// Nom del contenidor HTML que conté la vista de la capçalera del contenidor.
        /// </summary>
        public string HeaderTemplate { get; set; }
        /// <summary>
        /// Nom del contenidor HTML que conté la vista de les capçaleres de les columnes.
        /// </summary>
        public string RowHeaderTemplate { get; set; }
        /// <summary>
        /// Nom del contenidor HTML que conté la vista de les files per cada element del ListView.
        /// </summary>
        public string RowItemTemplate { get; set; }
        /// <summary>
        /// Nom del contenidor HTML que conté la vista de l'encapçalament de les columnes.
        /// </summary>
        public string RowFooterTemplate { get; set; }
        /// <summary>
        /// Nom del contenidor HTML que conté la vista de l'encapçalament del contenidor.
        /// </summary>
        public string FooterTemplate { get; set; }
        /// <summary>
        /// La plantilla del ListView mostra les metadates o no.
        /// </summary>
        public bool IsMetadataProvider { get; set; }
    }
}
