﻿using System.Collections.Generic;
using System.ComponentModel;

namespace fgxavi.ListView
{
    public interface ISortedField : IField
    {
        /// <summary>
        /// Direcció d'ordenació del camp: ascendent o descendent.
        /// </summary>
        ListSortDirection Direction { get; }
        /// <summary>
        /// Ordre del camp a la llista ordenada de camps.
        /// </summary>
        int? Order { get; }
    }
    public interface ISortedQueryOption
    {
        /// <summary>
        /// Llista ordenada dels camps seleccionats.
        /// </summary>
        SortedList<int, IColumn> SortedFields { get; }
    }
    public interface ISortedListView
    {
        /// <summary>
        /// Llista ordenada dels camps seleccionats.
        /// </summary>
        SortedList<int, IColumn> SortedFields { get; }
        /// <summary>
        /// Llista de camps.
        /// </summary>
        IList<IColumn> Fields { get; }
    }
    //public class SortedQuery<TParameters> : ISortedQuery<TParameters>
    //{
    //    public const int DefaultPageSize = 10;
    //    public SortedQuery(Func<ISortedQuery<TParameters>, TParameters> Converter, int PageSize)
    //    {
    //        this.Converter = Converter;
    //        this.PageSize = PageSize;
    //    }
    //    public SortedQuery(Func<ISortedQuery<TParameters>, TParameters> Converter)
    //        : this(Converter, DefaultPageSize)
    //    {
    //        this.Converter = Converter;
    //    }
    //    public TParameters Parameters { get; private set; }
    //    public Func<ISortedQuery<TParameters>, TParameters> Converter { get; set; }
    //    /// <summary>
    //    /// Modifica els paràmetres d'ordenació de la font de dades
    //    /// mitjançant les propietats de la instància.
    //    /// </summary>
    //    public virtual void Refresh()
    //    {
    //        var parameters = this.Converter(this);
    //        this.Parameters = parameters;
    //    }
    //    public int TotalItemCount { get; set; }
    //    public int PageSize { get; set; }
    //    public int PageNumber { get; set; }
    //    public int PageCount { get; private set; }
    //}
}
